<?php

/**
 * AVE.cms - Модуль Корзина
 *
 * @package AVE.cms
 * @subpackage module_Basket
 * @filesource
 */

/**
 * mySQL-запросы для установки, обновления и удаления модуля
 */

$module_sql_install = array();
$module_sql_deinstall = array();
$module_sql_update = array();

$module_sql_deinstall[] = "DROP TABLE IF EXISTS `%%PRFX%%_module_basket`;";
$module_sql_deinstall[] = "DROP TABLE IF EXISTS `%%PRFX%%_module_basket_payment`;";
$module_sql_deinstall[] = "DROP TABLE IF EXISTS `%%PRFX%%_module_basket_delivery`;";
$module_sql_deinstall[] = "DROP TABLE IF EXISTS `%%PRFX%%_module_basket_processing`;";

//Основная таблица
$module_sql_install[] = "CREATE TABLE `%%PRFX%%_module_basket` (
  `id` int(11) NOT NULL auto_increment,
  `basket_session_id` varchar(50) default NULL,
  `basket_product_id` int(11) default NULL,
  `basket_product_name_id` int(11) default NULL,
  `basket_product_price_id` int(11) default NULL,
  `basket_product_article_id` int(22) default NULL,
  `basket_product_size_id` int(22) default NULL,
  `basket_product_quantity` smallint(5) default NULL,
  `basket_product_amount` float(10,2) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

//Метод оплаты
$module_sql_install[] = "CREATE TABLE `%%PRFX%%_module_basket_payment` (
  `id` int(11) NOT NULL auto_increment,
  `payment_title` varchar(255) NOT NULL,
  `payment_price` text NOT NULL,
  `payment_price_operands` enum('Money','%','Text') NOT NULL default 'Money',
  `payment_description` text default NULL,
  `payment_delivery` tinytext default NULL,
  `payment_activ` tinyint(1) unsigned NOT NULL default '0',
  `payment_position` tinyint(2) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

//Выбор доставки
$module_sql_install[] = "CREATE TABLE `%%PRFX%%_module_basket_delivery` (
  `id` int(11) NOT NULL auto_increment,
  `delivery_title` varchar(255) NOT NULL,
  `delivery_price` text NOT NULL,
  `delivery_price_operands` enum('Money','%','Text') NOT NULL default 'Money',
  `delivery_description` text default NULL,
  `delivery_activ` tinyint(1) unsigned NOT NULL default '0',
  `delivery_position` tinyint(2) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";


//Тестовые данные
$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_delivery` VALUES ('1', 'Курьером по москве', '0', 'Money', '', '1', '1');";
$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_delivery` VALUES ('2', 'Курьером в подмосковье', '0', 'Money', '', '1', '2');";
$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_delivery` VALUES ('3', 'Почта России', '0', 'Money', '', '1', '3');";
$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_delivery` VALUES ('4', 'Самовывоз', '0', 'Money', '', '1', '4');";


$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_payment` VALUES (1, 'Наличными курьеру', 'Отдать бабло Курьеру', 'Text', 'Наличные при получении (по Москве) - оплата осуществляется наличными деньгами курьеру в момент доставки. После комплектации заказа наш менеджер свяжется с Вами по контактному телефону и еще раз уточнит параметры заказа и Ваш адрес. Если Вы, подтвердив заказ, в дальнейшем отказываетесь от его получения, то Вам необходимо оплатить стоимость доставки + 50 руб за каждую возвращенную позицию. В случае необходимости возврата или обмена изделия свяжитесь с нашим менеджером.', '1,2', 1, 1);";

$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_payment` VALUES (2, 'Наличными в офисе', '0.00', 'Money', 'Наличные при получении  - оплата осуществляется наличными деньгами в офисе компании. После комплектации заказа наш менеджер свяжется с Вами по контактному телефону и еще раз уточнит параметры заказа. Если Вы, подтвердив заказ, в дальнейшем отказываетесь от его получения, то Вам необходимо оплатить стоимость доставки + 50 руб за каждую возвращенную позицию. В случае необходимости возврата или обмена изделия свяжитесь с нашим менеджером.', '4', 1, 2);";

$module_sql_install[] = "INSERT INTO `%%PRFX%%_module_basket_payment` VALUES (3, 'Безналичная оплата', '10.00', '%', 'Банковский платеж - после оформления заказа Вы сразу же можете распечатать квитанцию для оплаты через банк. Большая просьба - после осуществления перевода сразу уведомить нас об отправке денег по адресу e-mail. Мы сформируем и отправим Ваш заказ в течение 3-5 рабочих дней с момента поступления денег на наш расчетный счет. Если заказанного товара не окажется на складе, наш менеджер обязательно свяжется с Вами для разрешения возникшей ситуации.', '3,4', 1, 3);";

// Обновление модуля
$module_sql_update[] = "
  UPDATE
    `%%PRFX%%_module`
  SET
    ModuleAveTag = '" . $modul['ModuleAveTag'] . "',
    ModulePHPTag = '" . $modul['ModulePHPTag'] . "',
    ModuleVersion = '" . $modul['ModuleVersion'] . "'
  WHERE
    ModuleSysName = '" . $modul['ModuleSysName'] . "'
  LIMIT 1;
";

$module_sql_update[] = "
  RENAME TABLE
    `%%PRFX%%_modul_basket_payment`
  TO
    `%%PRFX%%_module_basket_payment`
";

$module_sql_update[] = "
  RENAME TABLE
    `%%PRFX%%_modul_basket_delivery`
  TO
    `%%PRFX%%_module_basket_delivery`
";

$module_sql_update[] = "
  RENAME TABLE
    `%%PRFX%%_modul_basket_payment`
  TO
    `%%PRFX%%_module_basket_payment`
";
?>